<template>
  <div>
    <div :class="{ 'mt-selected': organisme.selected }" class="columns mt-div">
      <div class="column columns" @click="toggle">
        <div :class="resolveTypeOrganisme(organisme, 'col1-')" class="column is-3">
          <div class="col11">
            <b-icon v-if="hasEnfants && !isOpen" icon="home-plus"></b-icon>
            <b-icon v-else-if="hasEnfants && isOpen" icon="home-minus"></b-icon>
            <b-icon v-else icon="home-outline"></b-icon>
          </div>
          <div class="col1">
            {{ organisme.code }}
          </div>
        </div>
        <div class="column">
          {{ organisme.libelle }}
        </div>
        <div class="column is-2">
          {{ organisme.libelleTypeOrganisme }}
        </div>
        <div class="column is-2">
          {{ organisme.credo }}
        </div>
      </div>
      <div class="columns column is-narrow mt-action">
        <div v-if="estBrigade(organisme) && isAdminBrigade" class="column is-one-quarter">
          <b-tooltip label="Ajouter un régiment à cette brigade" type="is-light">
            <b-button type="is-primary" icon-left="plus" @click="addRegiment(organisme)"></b-button>
          </b-tooltip>
        </div>
        <div v-else-if="estRegiment(organisme)" class="column is-one-quarter">
          <b-tooltip label="Ajouter une unité à ce régiment" type="is-light">
            <b-button type="is-primary" icon-left="plus" @click="addUnite(organisme)"></b-button>
          </b-tooltip>
        </div>
        <div v-else class="column is-one-quarter" />
        <div v-if="estBrigade(organisme) && isAdmin" class="column is-one-quarter">
          <b-tooltip label="Modifier cet organisme" type="is-light">
            <b-button type="is-primary" icon-left="pencil" @click="editOrganisme(organisme)"></b-button>
          </b-tooltip>
        </div>
        <div v-else-if="estRegiment(organisme) && isAdminBrigade" class="column is-one-quarter">
          <b-tooltip label="Modifier cet organisme" type="is-light">
            <b-button type="is-primary" icon-left="pencil" @click="editOrganisme(organisme)"></b-button>
          </b-tooltip>
        </div>
        <div v-else-if="estUnite(organisme)" class="column is-one-quarter">
          <b-tooltip label="Modifier cet organisme" type="is-light">
            <b-button type="is-primary" icon-left="pencil" @click="editOrganisme(organisme)"></b-button>
          </b-tooltip>
        </div>
        <div v-if="!hasEnfants" class="column is-one-quarter">
          <b-tooltip label="Supprimer cet organisme" type="is-light">
            <b-button type="is-danger" icon-left="delete" @click="confirmerSupprimer(organisme)"></b-button>
          </b-tooltip>
        </div>
        <div v-else class="column" />
        <div v-if="estUnite(organisme)" class="column is-one-quarter">
          <b-tooltip label="Voir les utilisateurs de cet organisme" type="is-light">
            <nuxt-link
              :to="{ name: 'profil-dashboard-utilisateurs', params: { idOrganisme: organisme.id } }"
              class="columns column mt-marginless-bottom"
            >
              <b-button type="is-primary" icon-left="account-multiple"></b-button>
            </nuxt-link>
          </b-tooltip>
        </div>
        <div v-else class="column is-one-quarter" />
      </div>
    </div>
    <div v-show="isOpen" v-if="hasEnfants">
      <tree-item
        v-for="(child, index) in organisme.organismesEnfants"
        :key="index"
        class="item"
        :organisme="child"
        @confirmer-supprimer="confirmerSupprimer"
        @add-regiment="addRegiment"
        @add-unite="addUnite"
        @edit="editOrganisme"
      ></tree-item>
    </div>
    <div v-else class="column" />
  </div>
</template>
<script>
export default {
  name: 'TreeItem',
  props: {
    organisme: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    const isAdmin = this.$store.getters['context/isAdmin'];
    const isAdminBrigade = this.$store.getters['context/isAdminBrigade'];
    return {
      isAdmin,
      isAdminBrigade,
    };
  },
  computed: {
    hasEnfants() {
      return this.organisme.organismesEnfants && this.organisme.organismesEnfants.length > 0;
    },
    isOpen() {
      return this.organisme.isOpen;
    },
  },
  methods: {
    toggle() {
      if (this.hasEnfants) {
        this.organisme.isOpen = !this.organisme.isOpen;
      }
    },
    resolveTypeOrganisme(organisme, prefix = '') {
      const typeOrg = this.appTypesOrganismes.find((type) => organisme.idTypeOrganisme === type.id);
      return `${prefix}${typeOrg.code}`;
    },
    confirmerSupprimer(organisme) {
      this.$emit('confirmer-supprimer', organisme);
    },
    addRegiment(organisme) {
      this.$emit('add-regiment', organisme);
    },
    addUnite(organisme) {
      this.$emit('add-unite', organisme);
    },
    editOrganisme(organisme) {
      this.$emit('edit', organisme);
    },
    estBrigade(organisme) {
      const typeOrg = this.appTypesOrganismes.find((type) => organisme.idTypeOrganisme === type.id);
      return typeOrg.code === 'brigade';
    },
    estRegiment(organisme) {
      const typeOrg = this.appTypesOrganismes.find((type) => organisme.idTypeOrganisme === type.id);
      return typeOrg.code === 'regiment';
    },
    estUnite(organisme) {
      const typeOrg = this.appTypesOrganismes.find((type) => organisme.idTypeOrganisme === type.id);
      return typeOrg.code === 'unite';
    },
  },
};
</script>
<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-div {
  border-bottom: 1px solid $list-item-border-color-blue;
  border-radius: 0 !important;
  padding: 0.5em 0 0 0.75em;
}
.col1 {
  display: inline-block;
}
.col11 {
  width: 30px;
  display: inline-block;
}
.col1-regiment {
  padding-left: 2em;
}
.col1-unite {
  padding-left: 4em;
}
.item {
  cursor: pointer;
}
.mt-action {
  width: 180px;
}
.mt-selected {
  background-color: $pale-grey;
}
</style>
